%define _unpackaged_files_terminate_build 0
%define contentdir /home/httpd
%define suexec_caller nobody
%define mmn 20051115
%define vstring AnNyung
%define distro AnNyung

%{?_with_cent4:%define aprv 12}

Summary: Apache HTTP Server
Summary(ko): 아파치 HTTP 서버
Name: httpd
Version: 2.2.22
Release: 3%{?dist}
Epoch: 1
URL: http://httpd.apache.org/
Source0: http://www.apache.org/dist/httpd/httpd-%{version}.tar.bz2
Source3: httpd.logrotate
Source4: httpd.init
Source5: httpd.sysconf
Source10: httpd.conf
Source11: welcome.conf
Source12: manual.conf
Source13: ssl.conf
Source14: proxy_ajp.conf
# Documentation
Source32: html.xsl

# Tmon index file
Source100: annyung-index.html
Source104: ServerError.tar.gz
Source105: blank.gif
Source106: httpd_callstack.sh

# build/scripts patches
Patch1: httpd-2.2.19-apctl.patch
Patch2: httpd-2.2.19-apxs.patch
Patch3: httpd-2.2.19-deplibs.patch
Patch4: httpd-2.2.19-disablemods.patch
Patch5: httpd-2.2.19-layout.patch
# Features/functional changes
Patch20: httpd-2.2.22-release.patch
Patch21: httpd-2.2.19-xfsz.patch
Patch22: httpd-2.2.19-pod.patch
Patch23: httpd-2.2.19-export.patch
Patch24: httpd-2.2.22-corelimit.patch
Patch25: httpd-2.2.22-selinux.patch
# Bug fixes
Patch50: httpd-2.2.19-encode.patch
Patch51: httpd-2.2.19-authnoprov.patch
Patch52: httpd-2.2.19-logresline.patch

# Tmon Patch
Patch101: httpd-annyung-imbeded-apr.patch
Patch102: httpd-annyung-external-404-iframe.patch
Patch103: httpd-annyung-max-server-status-num.patch
Patch104: httpd-annyung-fixed-ssi-hangul.patch

License: ASL 2.0
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: autoconf, perl, pkgconfig, findutils
BuildRequires: db4-devel, expat-devel, zlib-devel, libselinux-devel
BuildRequires: apr%{?aprv}-devel >= 1.2.0, apr%{?aprv}-util-devel >= 1.2.0
%{!?_with_cent4:BuildRequires: pcre-devel >= 5.0} 
Requires: /etc/mime.types, gawk, /usr/bin/find, mailcap
Requires: initscripts apr%{?aprv} apr%{?aprv}-util httpd-conf-package
Requires(post): chkconfig
Obsoletes: httpd-suexec
BuildRequires: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv
BuildRequires: sh-utils, textutils, /usr/sbin/useradd
Provides: webserver
Provides: httpd-mmn = %{mmn}
Obsoletes: secureweb, mod_dav, mod_gzip, stronghold-apache, stronghold-htdocs
Obsoletes: mod_put, mod_roaming, mod_jk
%{!?_with_cent4:Conflicts: pcre < 4.0}
Conflicts: apache

%description
The Apache HTTP Server is a powerful, efficient, and extensible
web server.

Building option:
	--with cent4 : if build on cent4

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache HTTP server.
Summary(ko): 아파치 HTTP 서버를 이용한 개발 도구
Obsoletes: secureweb-devel, stronghold-apache-devel
Requires: apr%{?aprv}-devel, apr%{?aprv}-util-devel
Requires: pkgconfig
Conflicts: apache-devel
#Requires: httpd

%description devel
The httpd-devel package contains the APXS binary and other files
that you need to build Dynamic Shared Objects (DSOs) for the
Apache HTTP Server.

If you are installing the Apache HTTP server and you want to be
able to compile or develop additional modules for Apache, you need
to install this package.

%package manual
Group: Documentation
Summary: Documentation for the Apache HTTP server.
Summary(ko): 아파치 HTTP 서버 문서
Requires: httpd
Obsoletes: secureweb-manual

%description manual
The httpd-manual package contains the complete manual and
reference guide for the Apache HTTP server. The information can
also be found at http://httpd.apache.org/docs/2.2/.

%package ssl
Group: System Environment/Daemons
Summary: SSL/TLS module for the Apache HTTP server
Summary(ko): 아파치 HTTP 서버 SSL/TLS 모듈
BuildRequires: openssl-devel
Requires(post): openssl, /bin/cat
Requires: httpd, httpd-mmn
Obsoletes: stronghold-mod_ssl

%description ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%package tools
Group: System Environment/Daemons
Summary: Tools for use with the Apache HTTP Server
Summary(ko): 아파치 HTTP 서버와 함께 사용할 수 있는 도구
Requires: gdb

%description tools
The httpd-tools package contains tools which can be used with
the Apache HTTP Server.

%prep
%setup -q -a 104
%patch1 -p1 -b .apctl
%patch2 -p1 -b .apxs
%patch3 -p1 -b .deplibs
%patch4 -p1 -b .disablemods
%patch5 -p1 -b .layout

%patch21 -p1 -b .xfsz
%patch22 -p1 -b .pod
%patch23 -p1 -b .export
%patch24 -p1 -b .corelimit
%patch25 -p1 -b .selinux

# no -b to prevent droplets in install root
%patch50 -p1
%patch51 -p1 -b .authnoprov
%patch52 -p1 -b .logresline

# AnNyung patch
%patch102 -p1
%patch103 -p1
%patch104 -p1

# Patch in vendor/release string
sed "s/@VENDOR@/%{vstring}/;s/@RELEASE@/%{release}/" < %{PATCH20} | patch -p1 -b -z .release

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include include/ap_mmn.h | sed -n '/^2/p'`
if test "x${vmmn}" != "x%{mmn}"; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}.
   : Update the mmn macro and rebuild.
   exit 1
fi

: Building for '%{distro}' with MMN %{mmn} and vendor string '%{vstring}'

%build
# forcibly prevent use of bundled apr, apr-util, pcre
rm -rf srclib/{apr,apr-util}
%{!?_with_cent4:rm -rf srclib/pcre}

# regenerate configure scripts
autoheader && autoconf || exit 1

# Limit size of CHANGES to recent history
#echo '1,/Changes with Apache MPM/wq' | ed CHANGES

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
	support/apxs.in
# update location of migration guide in apachectl
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
	support/apachectl.in

CFLAGS=$RPM_OPT_FLAGS
SH_LDFLAGS="-Wl,-z,relro"
export CFLAGS SH_LDFLAGS

# Hard-code path to links to avoid unnecessary builddep
export LYNX_PATH=/usr/bin/links

function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
../configure \
	--prefix=%{_sysconfdir}/httpd \
	--exec-prefix=%{_prefix} \
	--bindir=%{_bindir} \
	--sbindir=%{_sbindir} \
	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--sysconfdir=%{_sysconfdir}/httpd/conf \
	--includedir=%{_includedir}/httpd \
	--libexecdir=%{_libdir}/httpd/modules \
	--datadir=%{contentdir} \
	--with-installbuilddir=%{_libdir}/httpd/build \
	--with-mpm=$mpm \
	--with-apr=%{_prefix} --with-apr-util=%{_prefix} \
	--enable-suexec --with-suexec \
	--with-suexec-caller=%{suexec_caller} \
	--with-suexec-docroot=%{contentdir} \
	--with-suexec-logfile=%{_localstatedir}/log/httpd/suexec.log \
	--with-suexec-bin=%{_sbindir}/suexec \
	--with-suexec-uidmin=500 --with-suexec-gidmin=100 \
	--enable-pie \
	%{!?_with_cent4:--with-pcre} \
	$*

%{__make} %{?_smp_mflags}
popd
}

# Build everything and the kitchen sink with the prefork build
mpmbuild prefork \
	--enable-mods-shared=all \
	--enable-ssl --with-ssl \
	--enable-proxy \
	--enable-cache --enable-mem-cache \
	--enable-file-cache --enable-disk-cache \
	--enable-ldap --enable-authnz-ldap \
	--enable-cgid \
	--enable-authn-anon --enable-authn-alias

# For the other MPMs, just build httpd and no optional modules
mpmbuild worker --enable-modules=none
#mpmbuild event --enable-modules=none

%install
rm -rf %{buildroot}

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
#mv docs/man/ab.8 docs/man/ab.1
#mv docs/man/logresolve.8 docs/man/logresolve.1

pushd prefork
make DESTDIR=%{buildroot} install
popd

# install alternative MPMs
install -m 755 worker/httpd %{buildroot}%{_sbindir}/httpd.worker
#install -m 755 event/httpd %{buildroot}%{_sbindir}/httpd.event

# for holding mod_dav lock database
mkdir -p %{buildroot}%{_localstatedir}/lib/dav

# create a prototype session cache
mkdir -p %{buildroot}%{_localstatedir}/cache/mod_ssl
touch %{buildroot}%{_localstatedir}/cache/mod_ssl/scache.{dir,pag,sem}

# create cache root
mkdir %{buildroot}%{_localstatedir}/cache/mod_proxy

# move utilities to /usr/bin
mv %{buildroot}%{_sbindir}/{ab,htdbm,logresolve,htpasswd,htdigest} \
   %{buildroot}%{_bindir}

# Make the MMN accessible to module packages
echo %{mmn} > %{buildroot}%{_includedir}/httpd/.mmn

# remove manual sources
find %{buildroot}%{contentdir}/manual \( \
    -name \*.xml -o -name \*.xml.* -o -name \*.ent -o -name \*.xsl -o -name \*.dtd \
    \) -print0 | xargs -0 rm -f

# Strip the manual down just to English and replace the typemaps with flat files:
set +x
for f in `find %{buildroot}%{contentdir}/manual -name \*.html -type f`; do
   if test -f ${f}.en; then
      cp ${f}.en ${f}
      rm ${f}.*
   fi
done
set -x

# logs
rmdir %{buildroot}%{_sysconfdir}/httpd/logs
mkdir -p %{buildroot}%{_localstatedir}/log/httpd

# symlinks for %{_sysconfdir}/httpd
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}%{_sysconfdir}/httpd/logs
ln -s ../..%{_localstatedir}/run %{buildroot}%{_sysconfdir}/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}%{_sysconfdir}/httpd/modules

# fix man page paths
sed -e "s|/usr/local/apache2/conf/httpd.conf|%{_sysconfdir}/httpd/conf/httpd.conf|" \
    -e "s|/usr/local/apache2/conf/mime.types|/etc/mime.types|" \
    -e "s|/usr/local/apache2/conf/magic|%{_sysconfdir}/httpd/conf/magic|" \
    -e "s|/usr/local/apache2/logs/error_log|/var/log/httpd/error_log|" \
    -e "s|/usr/local/apache2/logs/access_log|/var/log/httpd/access_log|" \
    -e "s|/usr/local/apache2/logs/httpd.pid|/var/run/httpd.pid|" \
    -e "s|/usr/local/apache2|%{_sysconfdir}/httpd|" < docs/man/httpd.8 \
  > %{buildroot}%{_mandir}/man8/httpd.8

# Make ap_config_layout.h libdir-agnostic
sed -i '/.*DEFAULT_..._LIBEXECDIR/d;/DEFAULT_..._INSTALLBUILDDIR/d' \
    %{buildroot}%{_includedir}/httpd/ap_config_layout.h

# Fix path to instdso in special.mk
sed -i '/instdso/s,top_srcdir,top_builddir,' \
    %{buildroot}%{_libdir}/httpd/build/special.mk

# Remove unpackaged files
mv %{buildroot}%{contentdir}/htdocs %{buildroot}%{contentdir}/html
rm -f %{buildroot}%{_libdir}/*.exp \
      %{buildroot}%{_sysconfdir}/httpd/conf/mime.types \
      %{buildroot}%{_libdir}/httpd/modules/*.exp \
      %{buildroot}%{_libdir}/httpd/build/config.nice \
      %{buildroot}%{_bindir}/ap?-config \
      %{buildroot}%{_sbindir}/{checkgid,dbmmanage,envvars*} \
      %{buildroot}%{contentdir}/html/* \
      %{buildroot}%{_mandir}/man1/dbmmanage.* \
      %{buildroot}%{contentdir}/cgi-bin/*

mkdir -p %{buildroot}%{_sysconfdir}/{rc.d/init.d,sysconfig,logrotate.d}
install -m644 %{SOURCE3} %{buildroot}%{_sysconfdir}/logrotate.d/httpd
install -m755 %{SOURCE4} %{buildroot}%{_sysconfdir}/rc.d/init.d/httpd
install -m644 %{SOURCE5} %{buildroot}%{_sysconfdir}/sysconfig/httpd

rm -rf %{buildroot}%{_sysconfdir}/httpd/conf/{original,extra}

mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
mkdir -p %{buildroot}%{_sysconfdir}/httpd/user.d
install -m644 %{SOURCE10} %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
install -m644 %{SOURCE11} %{buildroot}%{_sysconfdir}/httpd/user.d/welcome.conf
install -m644 %{SOURCE12} %{buildroot}%{_sysconfdir}/httpd/user.d/manual.conf
install -m644 %{SOURCE13} %{buildroot}%{_sysconfdir}/httpd/conf.d/ssl.conf
install -m644 %{SOURCE14} %{buildroot}%{_sysconfdir}/httpd/conf.d/proxy_ajp.conf

sed -i "s|@CONTENT_DIR@|%{contentdir}|g" %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf
#sed -i "s|@CONTENT_DIR@|%{contentdir}|g" %{buildroot}%{_sysconfdir}/httpd/user.d/welcome.conf

install -m644 %{SOURCE100} %{buildroot}%{contentdir}/error/noindex.html

install -m644 %{SOURCE105} %{buildroot}%{contentdir}/icons/blank.gif
install -m755 %{SOURCE106} %{buildroot}%{_sbindir}/httpd_callstack

# Make suexec a+rw so it can be stripped.  %%files lists real permissions
chmod 755 %{buildroot}%{_sbindir}/suexec

# Error Document
install -d -m755 $RPM_BUILD_ROOT%{contentdir}/error
cp -af ServerError/* $RPM_BUILD_ROOT/%{contentdir}/error/
cp -af ServerError/include/*.gif $RPM_BUILD_ROOT%{contentdir}/icons/

# move manual to /usr/share/httpd
mkdir -p %{buildroot}%{_datadir}/httpd/
mv %{buildroot}%{contentdir}/manual/ %{buildroot}%{_datadir}/httpd/

%post
# Register the httpd service
if [ $1 = 1 ]; then
	/sbin/chkconfig --add httpd
	/sbin/chkconfig --level 35 httpd on
fi

%preun
if [ $1 = 0 ]; then
	/sbin/service httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
fi

%check
# Check the built modules are all PIC
if readelf -d %{buildroot}%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
   : modules contain non-relocatable code
   exit 1
fi

# Verify that the same modules were built into the httpd binaries
./prefork/httpd -l | grep -v prefork > prefork.mods
for mpm in worker; do
  ./${mpm}/httpd -l | grep -v ${mpm} > ${mpm}.mods
  if ! diff -u prefork.mods ${mpm}.mods; then
    : Different modules built into httpd binaries, will not proceed
    exit 1
  fi
done

(
	if [ "%{contentdir}" != "/var/www" ]; then
		cd %{buildroot}/var
		ln -sf %{contentdir} www
		cd -
	fi
)

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)

#doc ABOUT_APACHE README CHANGES LICENSE VERSIONING NOTICE

%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/run
%dir %{_sysconfdir}/httpd/conf

%dir %{contentdir}/html/
/var/www

%{_sbindir}/ht*
%exclude %{_sbindir}/httpd_callstack
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%attr(4510,root,%{suexec_caller}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so

%attr(0700,nobody,nobody) %dir %{_localstatedir}/lib/dav
%attr(0700,nobody,nobody) %dir %{_localstatedir}/cache/mod_proxy

%{_mandir}/man?/*
%exclude %{_mandir}/man1/*.1*
%exclude %{_mandir}/man1/apxs.1*

%files manual
%defattr(-,root,root)
%{_datadir}/httpd/manual
%config(noreplace) %{_sysconfdir}/httpd/user.d/manual.conf

%files ssl
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_ssl.so
%attr(0700,nobody,root) %dir %{_localstatedir}/cache/mod_ssl
%attr(0600,nobody,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.dir
%attr(0600,nobody,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.pag
%attr(0600,nobody,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.sem
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf

%files devel
%defattr(-,root,root)
%{_includedir}/httpd
%{_sbindir}/apxs
%{_mandir}/man1/apxs.1*
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/*.sh

%files tools
%defattr(-,root,root)
%{_bindir}/*
%{_sbindir}/httpd_callstack
%{_mandir}/man1/*

%changelog
* Fri Jun 08 2012 JoungKyun.Kim <http://oops.org> 1:2.2.22-3%{?dist}
- momve to /var/log/httpd to httpd-conf package

* Mon Mar 22 2012 JoungKyun.Kim <http://oops.org> 1:2.2.22-2%{?dist}
- fixed broken echo hangul variable on ssi

* Fri Feb 17 2012 JoungKyun.Kim <http://oops.org> 1:2.2.22-1%{?dist}
- update 2.2.22

* Mon Aug 10 2011 JoungKyun.Kim <http://oops.org> 2.2.19-1%{?dist}
- update 2.2.19
- add MaxStatusProc directive
- add External404Title directive
- add External404Iframe directive. Default value is off
- if give --with cent4, use bundle pcre and require apr12 and apr12-util
